diff -r 1b0b563a81e6 mcabber/mcabber/commands.c
--- a/mcabber/mcabber/commands.c	Wed Mar 13 16:11:16 2013 +0200
+++ b/mcabber/mcabber/commands.c	Wed May 15 12:48:30 2013 +0300
@@ -2031,95 +2940,13 @@
                                HBB_PREFIX_INFO, 0);
     }
   }
+
+  return NULL;
 }
 
-// room_names() is a variation of do_info(), for chatrooms only
-static void room_names(gpointer bud, char *arg)
-{
-  const char *bjid;
-  char *buffer;
-  GSList *resources, *p_res;
-  enum { style_normal = 0, style_detail, style_short,
-         style_quiet, style_compact } style = 0;
-
-  if (*arg) {
-    if (!strcasecmp(arg, "--short"))
-      style = style_short;
-    else if (!strcasecmp(arg, "--quiet"))
-      style = style_quiet;
-    else if (!strcasecmp(arg, "--detail"))
-      style = style_detail;
-    else if (!strcasecmp(arg, "--compact"))
-      style = style_compact;
-    else {
-      scr_LogPrint(LPRINT_NORMAL, "Unrecognized parameter!");
-      return;
-    }
-  }
-
-  // Enter chat mode
-  scr_set_chatmode(TRUE);
-  scr_show_buddy_window();
-
-  bjid = buddy_getjid(bud);
-
-  buffer = g_slice_alloc(4096);
-  strncpy(buffer, "Room members:", 127);
-  scr_WriteIncomingMessage(bjid, buffer, 0, HBB_PREFIX_INFO, 0);
-
-  resources = buddy_getresources(bud);
-  for (p_res = resources ; p_res ; p_res = g_slist_next(p_res)) {
-    enum imstatus rstatus;
-    const char *rst_msg;
-
-    rstatus = buddy_getstatus(bud, p_res->data);
-    rst_msg = buddy_getstatusmsg(bud, p_res->data);
-
-    if (style == style_short) {
-      snprintf(buffer, 4095, "[%c] %s%s%s", imstatus2char[rstatus],
-               (char*)p_res->data,
-               rst_msg ? " -- " : "", rst_msg ? rst_msg : "");
-      scr_WriteIncomingMessage(bjid, buffer, 0, HBB_PREFIX_INFO, 0);
-    } else if (style == style_compact) {
-        enum imrole role = buddy_getrole(bud, p_res->data);
-        enum imaffiliation affil = buddy_getaffil(bud, p_res->data);
-        bool showaffil = (affil != affil_none);
-
-        snprintf(buffer, 4095, "[%c] %s (%s%s%s)",
-                 imstatus2char[rstatus], (char*)p_res->data,
-                 showaffil ? straffil[affil] : "\0",
-                 showaffil ? "/" : "\0",
-                 strrole[role]);
-        scr_WriteIncomingMessage(bjid, buffer, 0, HBB_PREFIX_INFO, 0);
-      } else {
-      // (Style "normal", "detail" or "quiet")
-      snprintf(buffer, 4095, "[%c] %s", imstatus2char[rstatus],
-               (char*)p_res->data);
-      scr_WriteIncomingMessage(bjid, buffer, 0, HBB_PREFIX_INFO, 0);
-      if (rst_msg && style != style_quiet) {
-        snprintf(buffer, 4095, "Status message: %s", rst_msg);
-        scr_WriteIncomingMessage(bjid, buffer,
-                                 0, HBB_PREFIX_INFO | HBB_PREFIX_CONT, 0);
-      }
-      if (style == style_detail) {
-        enum imrole role = buddy_getrole(bud, p_res->data);
-        enum imaffiliation affil = buddy_getaffil(bud, p_res->data);
-
-        snprintf(buffer, 4095, "Role: %s", strrole[role]);
-        scr_WriteIncomingMessage(bjid, buffer,
-                                 0, HBB_PREFIX_INFO | HBB_PREFIX_CONT, 0);
-        if (affil != affil_none) {
-          snprintf(buffer, 4095, "Affiliat.: %s", straffil[affil]);
-          scr_WriteIncomingMessage(bjid, buffer,
-                                   0, HBB_PREFIX_INFO | HBB_PREFIX_CONT, 0);
-        }
-      }
-    }
-    g_free(p_res->data);
-  }
-  g_slist_free(resources);
-  g_slice_free1(4096, buffer);
-}
+//
+//  /rename
+//
 
 static void move_group_member(gpointer bud, void *groupnamedata)
 {
@@ -2128,13 +2955,13 @@
 
   groupname = (char *)groupnamedata;
 
-  bjid = buddy_getjid(bud);
-  name = buddy_getname(bud);
-  type = buddy_gettype(bud);
+  bjid   = buddy_getjid(bud);
+  name   = buddy_getname(bud);
+  type   = buddy_gettype(bud);
   on_srv = buddy_getonserverflag(bud);
 
   if (on_srv)
-    xmpp_updatebuddy(bjid, name, *groupname ? groupname : NULL);
+    xmpp_updatebuddy(bjid, name, groupname);
   else {
     buddy_setgroup(bud, (char *)groupname);
     if ((type & ROSTER_TYPE_ROOM) && xmpp_is_bookmarked(bjid) &&
@@ -2143,32 +2970,52 @@
   }
 }
 
-static void do_rename(char *arg)
+// command
+
+static gchar *do_rename (const cmdopts_t *command, cmdarg_value_t *values);
+
+typedef enum {
+  pos_rename_jid   = 0,
+  pos_rename_name  = 1,
+  pos_rename_reset = 2,
+} pos_rename_t;
+
+// XXX:
+//  * custom type for completion by existing roster entry names
+static cmdopts_t def_rename = {
+  "rename",
+  cmd_default,
+  NULL,
+  do_rename,
+  (cmdopt_t[5]){
+    { 'r', "reset", { "reset", pos_rename_reset, cmdarg_switch, NULL, NULL } },
+    { 'n', "name",  { "name",  pos_rename_jid, cmdarg_chreq, ".", &cmdarg_type_roster_name, (gpointer)cmdarg_roster_normal|cmdarg_roster_name } },
+    { 'g', "group", { "group", pos_rename_jid, cmdarg_chreq, ".", &cmdarg_type_roster_group } },
+    { 'j', "jid",   { "jid",   pos_rename_jid, cmdarg_chreq, ".", &cmdarg_type_roster_bjid, (gpointer)cmdarg_roster_entity } },
+    {0}
+  },
+  (cmdarg_t[2]){
+    { "new name", pos_rename_name, cmdarg_chreq, NULL, &cmdarg_type_nonspace },
+    {NULL}
+  },
+  NULL,
+};
+
+static gchar *do_rename (const cmdopts_t *command, cmdarg_value_t *values)
 {
   gpointer bud;
-  const char *bjid, *group;
+  const char *bjid;
   guint type, on_srv;
-  char *newname, *p;
-  char *name_utf8;
-
-  if (!current_buddy)
-    return;
-  bud = BUDDATA(current_buddy);
+  char *newname = NULL;
+  gboolean reset;
+
+  bud     = values[pos_rename_jid].value.rjid.bud;
+  reset   = values[pos_rename_reset].value.swc;
+  newname = values[pos_rename_name].value.arg;
 
   bjid   = buddy_getjid(bud);
-  group  = buddy_getgroupname(bud);
+  on_srv = buddy_getonserverflag(bud);
   type   = buddy_gettype(bud);
-  on_srv = buddy_getonserverflag(bud);
-
-  if (type & ROSTER_TYPE_SPECIAL) {
-    scr_LogPrint(LPRINT_NORMAL, "You can't rename this item.");
-    return;
-  }
-
-  if (!*arg && !(type & ROSTER_TYPE_GROUP)) {
-    scr_LogPrint(LPRINT_NORMAL, "Please specify a new name.");
-    return;
-  }
 
   //if (!(type & ROSTER_TYPE_GROUP) && !on_srv) {
   //  scr_LogPrint(LPRINT_NORMAL,
@@ -2181,90 +3028,88 @@
   //  }
   //}
 
-  newname = g_strdup(arg);
-  // Remove trailing space
-  for (p = newname; *p; p++) ;
-  while (p > newname && *p == ' ') *p = 0;
-
-  strip_arg_special_chars(newname);
-
-  name_utf8 = to_utf8(newname);
-
   if (type & ROSTER_TYPE_GROUP) {
     // Rename a whole group
-    foreach_group_member(bud, &move_group_member, name_utf8);
+    foreach_group_member(bud, &move_group_member, (reset ? NULL : newname));
     // Let's jump to the previous buddy, because this group name should
     // disappear when we receive the server answer.
-    scr_roster_up_down(-1, 1);
+    // XXX: we can now "disappear" arbitrary buddy/group.
+    // Probably, we need some hook, when something appears/disappears,
+    // so that ui can know and react to that when it really happens, rather
+    // than doing this here.
+    //scr_roster_up_down(-1, 1);
   } else {
     // Rename a single buddy
-    guint del_name = 0;
-    if (!*newname || !strcmp(arg, "-"))
-      del_name = TRUE;
     if (on_srv) {
-      /* We do not rename the buddy right now because the server could reject
-       * the request.  Let's wait for the server answer.
-       */
-      xmpp_updatebuddy(bjid, (del_name ? NULL : name_utf8),
+      const char *group = buddy_getgroupname(bud);
+      // We do not rename the buddy right now because the server could reject
+      // the request.  Let's wait for the server answer.
+      xmpp_updatebuddy(bjid, (reset ? NULL : newname),
                        group && *group ? group : NULL);
     } else {
       // This is a local item, we rename it without adding to roster.
-      buddy_setname(bud, (del_name ? (char*)bjid : name_utf8));
+      buddy_setname(bud, (reset ? (char*)bjid : newname));
       if ((type & ROSTER_TYPE_ROOM) && xmpp_is_bookmarked(bjid) &&
           settings_opt_get_int("muc_bookmark_autoupdate"))
         room_bookmark(bud, NULL);
     }
   }
 
-  g_free(name_utf8);
-  g_free(newname);
   update_roster = TRUE;
+
+  return NULL;
 }
 
-static void do_move(char *arg)
+static gchar *do_move (const cmdopts_t *command, cmdarg_value_t *values);
+
+typedef enum {
+  pos_move_jid   = 0,
+  pos_move_name  = 1,
+} pos_move_t;
+
+// XXX:
+//  * custom type for completion by existing roster group names
+//    (share with rename, using types in chkdata?)
+static cmdopts_t def_move = {
+  "move",
+  cmd_default,
+  NULL,
+  do_move,
+  (cmdopt_t[5]){
+    { 'n', "name",  { "name",  pos_move_jid, cmdarg_chreq, ".", &cmdarg_type_roster_name, (gpointer)cmdarg_roster_entity|cmdarg_roster_name } },
+    { 'j', "jid",   { "jid",   pos_move_jid, cmdarg_chreq, ".", &cmdarg_type_roster_bjid, (gpointer)cmdarg_roster_entity } },
+    {0}
+  },
+  (cmdarg_t[2]){
+    { "new name", pos_move_name, cmdarg_eol|cmdarg_required, NULL, &cmdarg_type_nonspace },
+    {NULL}
+  },
+  NULL,
+};
+
+static gchar *do_move (const cmdopts_t *command, cmdarg_value_t *values)
 {
   gpointer bud;
   const char *bjid, *name, *oldgroupname;
   guint type, on_srv;
-  char *newgroupname, *p;
-  char *group_utf8;
-
-  if (!current_buddy)
-    return;
-  bud = BUDDATA(current_buddy);
-
-  bjid = buddy_getjid(bud);
-  name = buddy_getname(bud);
-  type = buddy_gettype(bud);
-  on_srv = buddy_getonserverflag(bud);
-
+  char *newgroupname;
+
+  bud          = values[pos_move_jid].value.rjid.bud;
+  newgroupname = values[pos_move_name].value.arg;
+
+  bjid         = buddy_getjid(bud);
+  name         = buddy_getname(bud);
+  type         = buddy_gettype(bud);
+  on_srv       = buddy_getonserverflag(bud);
   oldgroupname = buddy_getgroupname(bud);
 
-  if (type & ROSTER_TYPE_GROUP) {
-    scr_LogPrint(LPRINT_NORMAL, "You can't move groups!");
-    return;
-  }
-  if (type & ROSTER_TYPE_SPECIAL) {
-    scr_LogPrint(LPRINT_NORMAL, "You can't move this item.");
-    return;
-  }
-
-  newgroupname = g_strdup(arg);
-  // Remove trailing space
-  for (p = newgroupname; *p; p++) ;
-  while (p > newgroupname && *p == ' ') *p-- = 0;
-
-  strip_arg_special_chars(newgroupname);
-
-  group_utf8 = to_utf8(newgroupname);
-  if (strcmp(oldgroupname, group_utf8)) {
+  if (strcmp(oldgroupname, newgroupname)) {
     if (on_srv) {
-      xmpp_updatebuddy(bjid, name, *group_utf8 ? group_utf8 : NULL);
-      scr_roster_up_down(-1, 1);
-
-      /* We do not move the buddy right now because the server could reject
-       * the request.  Let's wait for the server answer.
-       */
+      xmpp_updatebuddy(bjid, name, newgroupname);
+      // XXX see /roster
+      //scr_roster_up_down(-1, 1);
+      // We do not move the buddy right now because the server could reject
+      // the request.  Let's wait for the server answer.
     } else {
       // This is a local item, we move it without adding to roster.
       guint msgflag;
@@ -2276,7 +3121,7 @@
       msgflag = buddy_getflags(bud) & ROSTER_FLAG_MSG;
       if (msgflag)
         roster_msg_setflag(bjid, FALSE, FALSE);
-      buddy_setgroup(bud, group_utf8);
+      buddy_setgroup(bud, newgroupname);
       if (msgflag)
         roster_msg_setflag(bjid, FALSE, TRUE);
       if ((type & ROSTER_TYPE_ROOM) && xmpp_is_bookmarked(bjid) &&
@@ -2285,33 +3130,160 @@
     }
   }
 
-  g_free(group_utf8);
-  g_free(newgroupname);
   update_roster = TRUE;
+
+  return NULL;
 }
 
-static void list_option_cb(char *k, char *v, void *f)
+//
+//  /set
+//
+
+static gchar *do_set (const cmdopts_t *command, cmdarg_value_t *values);
+
+typedef enum {
+  pos_set_assignment = 0,
+  pos_set_reset      = 1,
+  pos_set_file       = 2,
+} pos_set_t;
+
+static cmdopts_t *def_set = {
+  "set",
+  cmd_safe,
+  NULL,
+  do_setting,
+  (cmdopt_t[3]){
+    { 'd', "dump",  { "filename", pos_set_file,  cmdarg_required, NULL, &cmdarg_type_filename } },
+    { 'r', "reset", { "reset",    pos_set_reset, cmdarg_trigger,  NULL, NULL } },
+    {0}
+  },
+  (cmdarg_t[2]){
+    { "assignment", pos_set_assignment, cmdarg_eol|cmdarg_required, NULL, &cmdarg_type_assignment },
+    {NULL}
+  },
+  NULL,
+  (gpointer)SETTINGS_TYPE_OPTION
+};
+
+static cmdopts_t *def_alias = {
+  "alias",
+  cmd_safe,
+  NULL,
+  do_setting,
+  (cmdopt_t[3]){
+    { 'd', "dump",  { "filename", pos_set_file,  cmdarg_required, NULL, &cmdarg_type_filename } },
+    { 'r', "reset", { "reset",    pos_set_reset, cmdarg_trigger,  NULL, NULL } },
+    {0}
+  },
+  (cmdarg_t[2]){
+    { "assignment", pos_set_assignment, cmdarg_eol|cmdarg_required, NULL, &cmdarg_type_assignment },
+    {NULL}
+  },
+  NULL,
+  (gpointer)SETTINGS_TYPE_ALIAS
+};
+
+static cmdopts_t *def_bind = {
+  "bind",
+  cmd_safe,
+  NULL,
+  do_setting,
+  (cmdopt_t[3]){
+    { 'd', "dump",  { "filename", pos_set_file,  cmdarg_required, NULL, &cmdarg_type_filename } },
+    { 'r', "reset", { "reset",    pos_set_reset, cmdarg_trigger,  NULL, NULL } },
+    {0}
+  },
+  (cmdarg_t[2]){
+    { "assignment", pos_set_assignment, cmdarg_eol|cmdarg_required, NULL, &cmdarg_type_assignment },
+    {NULL}
+  },
+  NULL,
+  (gpointer)SETTINGS_TYPE_BINDING
+};
+
+static const setting_cb_t def_set_data = {
+  SETTINGS_TYPE_OPTION,
+  "%%-%us = [%%s]",
+  "No options found",
+  "Option %s is not set",
+  "%s = [%s]",
+  "set %%-%us = %%s",
+};
+
+static void settings_build_namelist_cb (char *k, char *v, void *f)
 {
   GSList **list = f;
   *list = g_slist_insert_sorted(*list, k, (GCompareFunc)strcmp);
 }
 
-static void do_set(char *arg)
+static void setting_dump_to_file_cb (char *key, char *value, void *userdata)
 {
-  guint assign;
-  gchar *option, *value;
-  gchar *option_utf8;
-
-  if (!*arg) {
-    // list all set options
-    GSList *list = NULL;
-    // Get sorted list of keys
-    settings_foreach(SETTINGS_TYPE_OPTION, list_option_cb, &list);
+  // foo cb = ...;
+  GString *line = cb....;
+  // foo file = cb....;
+  g_string_printf (line, "%s %s = \"", command -> name, key);
+  // unsecape value
+  key = value;
+  do {
+    if (*key == '"' || *key == '\\') {
+      g_string_append_len (line, value, key - value);
+      g_string_append_c (line, '\\');
+      value = key;
+      key ++;
+    } else if (*key == '\0') {
+      g_string_append_len (line, value, key - value);
+    } else {
+      key ++;
+    }
+  } while (*key);
+  g_string_append_c (line, '"');
+  // write the line here
+}
+
+// eol      = as is
+// plain    = only one word
+// catchall = backescape quotes/escapes
+// default  = quote
+static void cmdarg_unescape (
+
+static gchar *do_setting (const cmdopts_t *command, cmdarg_value_t *values)
+{
+  gchar    *option    = values[pos_set_assignment].value.assign.key;
+  gchar    *value     = values[pos_set_assignment].value.assign.value;
+  gboolean assignment = values[pos_set_assignment].value.assign.assignment;
+  guint    stype     = (guint)(command -> userdata);
+  gboolean reset = XXX;
+  const char *template = "%%-%us = [%%s]";
+  const char *msg1 = "No options found.";
+  const char *msg2 = "Option %s is not set";
+  const char *msg3 = "%s = [%s]";
+  gchar *filename = values[pos_set_filename].value.fname.local;
+
+    // open file here
+    GString *line = g_string_new (NULL);
+    // foo cb = {..., line};
+    if (!option) {
+      settings_foreach(stype, settings_dump_to_file_cb, cb);
+    } else {
+      settings_dump_to_file_cb (option, settings_get (stype, option), cb);
+    }
+    g_string_free (line, TRUE);
+    // close file here
+  }
+
+  if (option == NULL) {
+    GSList *list  = NULL;
+    
+    settings_foreach(stype, settings_build_namelist_cb, &list);
+
     if (list) {
-      gsize max = 0;
-      gsize maxmax = scr_gettextwidth() / 3;
+      gsize  max    = 0;
+      gsize  maxmax = scr_gettextwidth() / 3;
       GSList *lel;
-      gchar *format;
+      gchar  *format;
+
+      // Get sorted list of keys
+
       // Find out maximum key length
       for (lel = list; lel; lel = lel->next) {
         const gchar *key = lel->data;
@@ -2324,50 +3296,39 @@
           }
         }
       }
+
       // Print out list of options
-      format = g_strdup_printf("%%-%us = [%%s]", (unsigned)max);
+      format = g_strdup_printf(template, (unsigned)max);
       for (lel = list; lel; lel = lel->next) {
         const gchar *key = lel->data;
-        scr_LogPrint(LPRINT_NORMAL, format, key, settings_opt_get(key));
+        scr_log_print(LPRINT_NORMAL, format, key, settings_get(stype, key));
       }
       g_free(format);
       scr_setmsgflag_if_needed(SPECIAL_BUFFER_STATUS_ID, TRUE);
       scr_setattentionflag_if_needed(SPECIAL_BUFFER_STATUS_ID, TRUE,
                                  ROSTER_UI_PRIO_STATUS_WIN_MESSAGE, prio_max);
-    } else
-      scr_LogPrint(LPRINT_NORMAL, "No options found.");
-    return;
+    } else {
+      scr_log_print (LPRINT_NORMAL, "No options found.");
+    }
+  } else if (value == NULL && !reset) {
+    const char *val = settings_opt_get(option);
+    if (val)
+      scr_LogPrint(LPRINT_NORMAL, "%s = [%s]", option, val);
+    else
+      scr_LogPrint(LPRINT_NORMAL, "Option %s is not set", option);
+  } else {
+    // Update the option
+    // Maybe some options should be protected when user is connected (server,
+    // username, etc.).  And we should catch some options here, too
+    // (hide_offline_buddies for ex.)
+    if (!value) {
+      settings_del(stype, option);
+    } else {
+      settings_set(stype, option, value);
+    }
   }
 
-  assign = parse_assigment(arg, &option, &value);
-  if (!option) {
-    scr_LogPrint(LPRINT_NORMAL, "Set what option?");
-    return;
-  }
-  option_utf8 = to_utf8(option);
-  g_free(option);
-  if (!assign) {  // This is a query
-    const char *val = settings_opt_get(option_utf8);
-    if (val)
-      scr_LogPrint(LPRINT_NORMAL, "%s = [%s]", option_utf8, val);
-    else
-      scr_LogPrint(LPRINT_NORMAL, "Option %s is not set", option_utf8);
-    g_free(option_utf8);
-    return;
-  }
-  // Update the option
-  // Maybe some options should be protected when user is connected (server,
-  // username, etc.).  And we should catch some options here, too
-  // (hide_offline_buddies for ex.)
-  if (!value) {
-    settings_del(SETTINGS_TYPE_OPTION, option_utf8);
-  } else {
-    gchar *value_utf8 = to_utf8(value);
-    settings_set(SETTINGS_TYPE_OPTION, option_utf8, value_utf8);
-    g_free(value_utf8);
-    g_free(value);
-  }
-  g_free(option_utf8);
+  return NULL;
 }
 
 static void dump_alias(char *k, char *v, void *param)
@@ -2466,52 +3427,37 @@
   g_free(k_code);
 }
 
+#if 0
+
 static void do_rawxml(char *arg)
 {
-  char **paramlst;
-  char *subcmd;
+  cmdopts_t options = {
+    "rawxml",
+    NULL,
+    (cmdarg_t[1]){
+      { CMDOPT_REQUIRED | CMDOPT_SUBCOMMAND | CMDOPT_LAST, { .cmd = NULL } },
+    },
+    (cmdopts_t[1]){
+      { "send", NULL,
+        (cmdarg_t[1]){
+          { CMDOPT_REQUIRED | CMDOPT_CATCHALL | CMDOPT_PLAIN | CMDOPT_LAST,
+            { .arg = NULL } },
+        },
+        NULL },
+    },
+  };
 
   if (!xmpp_is_online()) {
     scr_LogPrint(LPRINT_NORMAL, "You are not connected.");
     return;
   }
 
-  paramlst = split_arg(arg, 2, 1); // subcmd, arg
-  subcmd = *paramlst;
-  arg = *(paramlst+1);
-
-  if (!subcmd || !*subcmd) {
-    scr_LogPrint(LPRINT_NORMAL, "Please read the manual page"
-                 " before using /rawxml :-)");
-    free_arg_lst(paramlst);
+  if (cmdopts_parse(arg, &options))
     return;
-  }
-
-  if (!strcasecmp(subcmd, "send"))  {
-    gchar *buffer;
-
-    if (!subcmd || !*subcmd) {
-      scr_LogPrint(LPRINT_NORMAL, "Missing parameter.");
-      free_arg_lst(paramlst);
-      return;
-    }
-
-    // We don't strip_arg_special_chars() here, because it would be a pain for
-    // the user to escape quotes in a XML stream...
-
-    buffer = to_utf8(arg);
-    if (buffer) {
-      scr_LogPrint(LPRINT_NORMAL, "Sending XML string");
-      lm_connection_send_raw(lconnection, buffer, NULL);
-      g_free(buffer);
-    } else {
-      scr_LogPrint(LPRINT_NORMAL, "Conversion error in XML string.");
-    }
-  } else {
-    scr_LogPrint(LPRINT_NORMAL, "Unrecognized parameter!");
-  }
-
-  free_arg_lst(paramlst);
+
+  scr_LogPrint(LPRINT_NORMAL, "Sending XML string");
+  lm_connection_send_raw(lconnection, options.cmds[0].args[0].value.arg, NULL);
+  cmdopts_free(&options);
 }
 
 //  check_room_subcommand(arg, param_needed, buddy_must_be_a_room)
@@ -2815,6 +3761,8 @@
   free_arg_lst(paramlst);
 }
 
+#endif
+
 void cmd_room_leave(gpointer bud, char *arg)
 {
   gchar *roomid, *desc;
@@ -2833,6 +3781,8 @@
   g_free(roomid);
 }
 
+#if 0
+
 static void room_nick(gpointer bud, char *arg)
 {
   if (!buddy_getinsideroom(bud)) {
@@ -2874,7 +3824,7 @@
   fjid_utf8 = g_strdup_printf("%s/%s", buddy_getjid(bud), nick_utf8);
   g_free (nick_utf8);
   msg = to_utf8(arg);
-  send_message_to(fjid_utf8, msg, NULL, LM_MESSAGE_SUB_TYPE_NOT_SET, FALSE);
+  send_message_to(fjid_utf8, msg, NULL, msgtype_not_set, FALSE);
   g_free(fjid_utf8);
   g_free(msg);
   free_arg_lst(paramlst);
@@ -3052,6 +4002,8 @@
   free_arg_lst(paramlst);
 }
 
+#endif
+
 //  cmd_room_whois(..)
 // If interactive is TRUE, chatmode can be enabled.
 // Please note that usernick is expected in UTF-8 locale iff interactive is
@@ -3209,6 +4161,8 @@
   g_free (tmpnick);
 }
 
+#if 0
+
 static void display_all_bookmarks(void)
 {
   GSList *bm, *bmp;
